/**
 * This file contains some types to make our
 * lifes easier when copy and pasting Java code.
 * With it we can keep int, float, etc., references
 * in code to keep as close as possible as the Java version
 * but without the need to sacrifice ourselves with boring
 * and annoying things.
 */

declare type byte = number;
declare type short = number;
declare type int = number;
declare type float = number;

declare type char = number;
// declare type String = string;

declare type List<T> = Array<T>;
declare type Collection<T> = Array<T>;
declare type Deque<T> = Array<T>;
